----------------------------------------------------------------------------
-- General Procedures ==> Used for Corndog
-- Darren Hewer - Last edit 98/12/27                                        
-- This file was the recipient of the 'sloppiest include file' award!
-- (Or, at least, if that existed, it would have won it. ^_-)
----------------------------------------------------------------------------

without warning
include machine.e           

global integer fcolor, bcolor
global object junk
global integer k_up, k_down, k_left, k_right
constant text = allocate(21)
fcolor = 7
bcolor = 0
k_up = 328
k_down = 336
k_left = 331
k_right = 333

-- This part allows editing of all palette colors ... thanks Pete!
global procedure allow_all_paledit ()
poke(text, {
#50,                    --    0: push eax
#52,                    --    1: push edx
#BA,#DA,#03,#00,#00,    --    2: mov edx,#3DA
#EC,                    --    7: in al,dx
#B2,#C0,                --    8: mov dl, #C0
#FA,                    --    A: cli
#B0,#00,                --    B: mov al, text_color (12)
#EE,                    --    D: out dx, al
#B0,#00,                --    E: mov al, index (15)
#EE,                    --   10: out dx, al
#FB,                    --   11: sti
#5A,                    --   12: pop edx
#58,                    --   13: pop eax
#C3})
for i = 0 to 15 do       -- this is the code you need
    poke(text + 12, i)   -- it makes colors 0-15 index into 
    poke(text + 15, i)   -- palette entries 0-15,
    call(text)           -- instead of 0-5,20,7,56-63
end for
poke(text + 12, #20) -- don't forget this or 
call(text)           -- the screen might be blank
end procedure
-- END of palette stuff!

global type file_number(integer x)
    return x >= -1
end type

global procedure locate (integer x, integer y)
    position (y, x)
end procedure

-- Delays a set # of seconds
global procedure delay (atom seconds)
    atom until
    until = time() + seconds 
    while time() < until do
    end while
end procedure

-- Clear keyboard buffer
global procedure clear_buff ()
    object woo          
    woo = 1
    while woo != -1 do
        woo = get_key ()    
    end while
end procedure

global procedure set_color (integer c)
    fcolor = c
    text_color (c)
end procedure     
global procedure set_bkcolor (integer c)
    bcolor = c
    bk_color (c)    
end procedure

-- Converts display_text_image attribute int value to a {fc, bc} sequence
global function attrib2colors (integer clr)
    sequence colorseq
    colorseq = {0, 0}
    colorseq [2] = floor (clr / 16)
    colorseq [1] = clr - (colorseq [2] * 16)
    return colorseq    
end function   
                  
-- Put a string directly
-- This routine by the funky David Cuny
-- (I made edits so it would work with my own 'txt' routine)
global procedure ps ( object text )
    sequence cursorAt, colors
    integer thisRow, thisCol, bpl
    integer attribute, pointer  
    integer SCREEN_WIDE, SCREEN_DEEP, SCREEN_MEMORY
    colors = {0, 0}
    colors [1] = fcolor
    colors [2] = bcolor
    SCREEN_WIDE = 80
    SCREEN_DEEP = 25
    SCREEN_MEMORY = #B8000
    -- convert to a list if text is a single byte
    -- this is to save me from myself
    if atom( text ) then
            text = { text }
    end if
    -- get cursor location
    cursorAt = get_position()
    thisRow = cursorAt[1]
    thisCol = cursorAt[2]
    -- if single line, convert to a list
    if atom( text[1] ) then
        -- make it an item in a list
        text = { text }
    end if
    -- combine the colors into a single attribute byte
    attribute = ( colors[2] * #10 ) + colors[1]
    -- video is located at HB8000 for color, and HB0000 for monochrome
    -- bytes per line
    bpl = SCREEN_WIDE*2
    for row = 1 to length( text ) do
        -- calculate offset onto screen (line, col)
        pointer = SCREEN_MEMORY             -- start of video
            + ( (thisRow+row-2) * bpl )     --  bytes per line
            + ( (thisCol-1) * 2 )           -- 2 bytes per line
        for col = 1 to length( text[row] ) do
            poke( pointer, text[row][col] )
            poke( pointer+1, attribute )
            pointer = pointer + 2
        end for
    end for
     -- new row
    thisRow = thisRow + length(text) - 1
    if thisRow > SCREEN_DEEP then 
        thisRow = SCREEN_DEEP 
    end if
    -- new column
    thisCol = thisCol + length( text[length(text)] )
    if thisCol > SCREEN_WIDE then 
        thisCol = SCREEN_WIDE 
    end if
    -- reposition cursor
    position( thisRow, thisCol )
end procedure

-- Toggles 'iCE' colors (as Kev would say)
-- Thanks be to David Cuny for this routine
global procedure intense ( integer flag )
    sequence inReg, outReg
    inReg = repeat( 0, 10 )         -- initialize register list
    inReg[REG_AX] = #1003           -- function 10, subfunction 03
    inReg[REG_BX] = flag            -- enable/disable intensity
    outReg = dos_interrupt( #10, inReg )  -- bios call
end procedure

-- Removes the black line btwn certain chars
-- This routine was converted from ASM (originally by Greg Janson)
-- to EU code by Pete Eberlein
global procedure egachars ()
    sequence regs
    regs = repeat(0,10)
    regs[REG_AX] = #1201
    regs[REG_BX] = #0030
    regs = dos_interrupt(#10, regs)
    regs[REG_AX] = #0003
    regs = dos_interrupt(#10, regs)    
end procedure

-- Used to put text to the screen w. MZX-style color modifiers (ie. ~ or @)
global procedure txtold (sequence text)
    integer z
    z = 1
    while z <= length (text) do
        if length (text) = 1 then  -- Gives ability to do '@/~' by themselves
            ps (text [z])
            exit    
        end if
        if text [z] = '~' then
            z = z + 1
            if (text [z] - 48 > -1) and (text [z] - 48 < 16) then
                fcolor = text [z] - 48
            elsif text [z] = 'A' or text [z] = 'a' then
                fcolor = 10
            elsif text [z] = 'B' or text [z] = 'b' then
                fcolor = 11
            elsif text [z] = 'C' or text [z] = 'c' then
                fcolor = 12
            elsif text [z] = 'D' or text [z] = 'd' then
                fcolor = 13
            elsif text [z] = 'E' or text [z] = 'e' then
                fcolor = 14
            elsif text [z] = 'F' or text [z] = 'f' then
                fcolor = 15
            end if
            z = z + 1
        elsif text [z] = '@' then
            z = z + 1
            if (text [z] - 48 > -1) and (text [z] - 48 < 16) then
                bcolor = text [z] - 48  
            elsif text [z] = 'A' or text [z] = 'a' then
                bcolor = 10
            elsif text [z] = 'B' or text [z] = 'b' then
                bcolor = 11
            elsif text [z] = 'C' or text [z] = 'c' then
                bcolor = 12
            elsif text [z] = 'D' or text [z] = 'd' then
                bcolor = 13
            elsif text [z] = 'E' or text [z] = 'e' then
                bcolor = 14
            elsif text [z] = 'F' or text [z] = 'f' then
                bcolor = 15                
            end if
            z = z + 1
        else  
            ps (text [z]) 
            z = z + 1 
        end if      
    end while    
end procedure

-- New txt routine: Doesn't use 'ps' at all ... uses display_text_image
global procedure txt (sequence text)
    sequence blit, pos
    integer z, tmpc, totchar   
    blit = {}
    z = 1                   
    totchar = 0
    pos = get_position ()
    while z <= length (text) do
        if length (text) = 1 then  -- Gives ability to do '@/~' by themselves
            totchar = 1
            tmpc = fcolor + (bcolor * 16)
            blit = blit & text
            blit = blit & tmpc
            exit    
        end if
        if text [z] = '~' then
            z = z + 1
            if (text [z] - 48 > -1) and (text [z] - 48 < 16) then
                fcolor = text [z] - 48
            elsif text [z] = 'A' or text [z] = 'a' then
                fcolor = 10
            elsif text [z] = 'B' or text [z] = 'b' then
                fcolor = 11
            elsif text [z] = 'C' or text [z] = 'c' then
                fcolor = 12
            elsif text [z] = 'D' or text [z] = 'd' then
                fcolor = 13
            elsif text [z] = 'E' or text [z] = 'e' then
                fcolor = 14
            elsif text [z] = 'F' or text [z] = 'f' then
                fcolor = 15
            end if
            z = z + 1
        elsif text [z] = '@' then
            z = z + 1
            if (text [z] - 48 > -1) and (text [z] - 48 < 16) then
                bcolor = text [z] - 48  
            elsif text [z] = 'A' or text [z] = 'a' then
                bcolor = 10
            elsif text [z] = 'B' or text [z] = 'b' then
                bcolor = 11
            elsif text [z] = 'C' or text [z] = 'c' then
                bcolor = 12
            elsif text [z] = 'D' or text [z] = 'd' then
                bcolor = 13
            elsif text [z] = 'E' or text [z] = 'e' then
                bcolor = 14
            elsif text [z] = 'F' or text [z] = 'f' then
                bcolor = 15                
            end if
            z = z + 1
        else                             
            totchar = totchar + 1
            tmpc = fcolor + (bcolor * 16)
            blit = blit & text [z]
            blit = blit & tmpc
            z = z + 1 
        end if      
    end while                   
    --print (1, blit)
    --junk = wait_key ()
    display_text_image ({pos[1], pos[2]}, {blit})
    if pos[2] + totchar < 81 then
        position (pos[1], pos[2] + totchar)    
    end if
end procedure

global procedure txtf (sequence mask, sequence args)
    txt (sprintf (mask, args))                                                
end procedure

global procedure txt_int (integer int)
    txt (sprintf ("%d", {int}))
end procedure

------------------------------------------
-- Get a line of text (sequence) from user
global function getstr (integer posx, integer posy, integer len)
    sequence returntxt
    integer key
    returntxt = ""
    key = -1
    locate (posx, posy)
    for z = 1 to len do
        txt (" ")    
    end for
    locate (posx, posy)
    cursor (BLOCK_CURSOR)
    while 1 do         
        key = get_key ()
        if key = 8 then  -- Backspace        
            if compare (returntxt, "") != 0 then
                returntxt = returntxt [1..length(returntxt) - 1]
                posx = posx - 1           
                locate (posx, posy)
                txt (" ")
                locate (posx, posy)
            end if     
        elsif key = 13 or key = 27 then  -- Enter / ESC
            exit
        elsif key != -1 and key != '@' and key != '~' and
            length (returntxt) <= len - 1 then  -- Text     
            returntxt = append (returntxt, key)
            txt ({key})
            posx = posx + 1
            locate (posx, posy)
        end if
    end while
    if key = 27 then
        return -1
    else    
        return returntxt        
    end if
end function

------------------------------------------
-- Gets an integer (inc. negative) from user with a maxlen
global function getint (integer posx, integer posy, integer maxlen)
    integer numint, key, cnt, negative
    sequence numseq, cpos, tempseq                 
    position (posy, posx)
    key = -1                
    numint = 0          
    negative = 1
    numseq = ""             
    locate (posx, posy)
    for z = 1 to maxlen do
        txt (" ")    
    end for    
    locate (posx, posy)
    cursor (BLOCK_CURSOR)
    -- Get a sequence of only #'s
    while 1 do            
        key = get_key ()
        if key != -1 then
            cpos = get_position ()
            if key = 27 or key = 13 then
                exit    
            elsif key >= 48 and key <= 57 and  -- Chrs. btwn 0 and 9
            length (numseq) < maxlen then
                numseq = numseq & key  
                txt ({key})
            elsif key = '-' and length (numseq) = 0 then  -- Negatives
                numseq = numseq & '-'  
                txt ({key})     
            elsif key = 8 and length (numseq) >= 1 then  -- Backspace
                tempseq = ""
                for p = 1 to length (numseq) - 1 do
                    tempseq = tempseq & numseq [p]
                end for
                numseq = tempseq
                position (cpos [1], cpos [2] - 1)
                txt (" ")
                position (cpos [1], cpos [2] - 1)
            end if    
        end if
    end while 
    -- Check for a negative value
    if length (numseq) > 0 then
        if numseq [1] = '-' then
            negative = -1        
            tempseq = ""
            for z = 2 to length (numseq) do
                tempseq = tempseq & numseq [z]    
            end for                           
            numseq = tempseq
        end if
        -- Convert a 'string' of numbers to an integer
        cnt = -1
        for z = length (numseq) to 1 by -1 do
            cnt = cnt + 1
            -- The 'magic' line. ;)
            numint = numint + (numseq [z] - 48) * power (10, cnt)       
        end for     
        -- Multiplies by 'negative' var (which is -1 if number is negative)
        numint = numint * negative
        cursor (NO_CURSOR)
        return numint      
    else
        return "null"
    end if
end function     

-- Centers text on screen using txt
global procedure center (sequence colors, object text, integer yval)
    integer indent
    indent = floor ((80 - length (text)) / 2) + 1
    position (yval, indent)
    txt (text)    
end procedure

-- Fills rectangle area w. a color (with top&bottom tabs! yay!)
global procedure colorfill (integer x, integer y, integer x2, integer y2, integer clr)
    sequence long, top, bottom  
    fcolor = 0
    bcolor = clr      
    long = ""                                  
    top = ""
    bottom = ""
    long = "" & repeat (' ', x2 - x - 1) & ""
    top =  "" & repeat ('', x2 - x - 1) & ""
    bottom =  "" & repeat ('', x2 - x - 1) & ""
    locate (x, y)
    txt (top)
    for z = y + 1 to y2 - 1 do
        locate (x, z)   
        txt (long)        
    end for
    locate (x, y2)
    txt (bottom)
end procedure

-- Like colorfill, but more generic to be used for drawing actual
-- game boxes (outline only)
global procedure box (integer x, integer y, integer x2, integer y2)
    sequence top, bottom  
    --long = ""                                  
    --top = ""
    --bottom = ""
    --long = "" & repeat (' ', x2 - x - 1) & ""
    top =  "" & repeat ('', x2 - x - 1) & ""
    bottom =  "" & repeat ('', x2 - x - 1) & ""
    locate (x, y)
    txt (top)
    for z = y + 1 to y2 - 1 do
        locate (x, z)   
        txt ("")
        locate (x2, z)
        txt ("")                
    end for
    locate (x, y2)
    txt (bottom)
end procedure

-- Ask's a yes/no question to user
global function ask (sequence question) 
    sequence back
    integer choice, pos, key         
    choice = 0         
    pos = 0                 
    key = 1               
    cursor (NO_CURSOR)
    back = save_text_image ({8, 10}, {13, 51})
    display_text_image ({8, 10}, ask_screen)
    locate (12, 9)
    txt ("@1~F")
    txt (question)                                             
    -- Get user's choice ...
    clear_buff ()
    while 1 do
        if key != -1 then
            locate (22, 12)
            if pos = 0 then
                txt ("~F@3 Yes @1         ~7@0 No ")
            else
                txt ("~7@0 Yes @1         ~F@3 No ")            
            end if   
        end if     
        key = get_key ()
        if key = k_up or key = k_down or key = k_left or key = k_right then
            if pos = 1 then
                pos = 0
            else
                pos = 1    
            end if
        end if
        if key = 27 or key = 13 or  -- ESC, Enter, Y or N
            key = 'Y' or key = 'y' or key = 'N' or key = 'n' then
            exit    
        end if
    end while     
    -- 1 = Yes, 0 = No
    if (key = 'Y' or key = 'y') or (pos = 0 and key = 13) then 
        choice = 1    
    end if
    display_text_image ({8, 10}, back) 
    cursor (BLOCK_CURSOR)
    return choice
end function

-- Returns a sequence in format: {{filename, ['d'/'f']}, {etc}} for dirlist
global function grabdir (sequence wildcard)  
    sequence raw, newlist
    raw = dir ("*.*")           
    newlist = {}
    -- Remove all files not fitting the wildcard given
    for z = 1 to length (raw) do 
        if wildcard_file (wildcard, raw[z][1]) then  -- wildcard files
            newlist = newlist & {{raw[z][1], 'f'}}        
        end if
        -- ***COMMENT IN TO ALLOW CHANGING OF DIRS!       
        --if compare (raw[z][2], "d") = 0 then
        --    newlist = newlist & {{raw[z][1], 'd'}}
        --end if
    end for   
    -- Alphabetize 'em!
    newlist = sort (newlist)
    return newlist    
end function

-- Brings up menu for user to choose a file
global function dirlist (sequence title, sequence wildcard)
    object newlist, key
    sequence tempseq, back
    integer update, pointer, dirlength, bah
    cursor (NO_CURSOR)           
    back = save_text_image ({3, 10}, {23, 51})
    display_text_image ({3, 10}, loadfile_screen)
    locate (12, 4)
    txtf ("@8~FSelect %s to load", {title})
    update = 1
    pointer = 1    
    newlist = grabdir (wildcard)
    dirlength = length (newlist)
    -----------
    -- Show 'em  
    while 1 do
        if update = 1 then                
            -- Show list of boards
            locate (12, 4)
            txtf ("@8~FSelect %s to load", {title})
            for z = pointer to pointer + 6 do
                if z > dirlength then
                    locate (17, z - pointer + 13)
                    txt ("                           ")
                    exit    
                end if         
                -- 'if' allows display of hilited board (middle)
                if z = pointer then
                    locate (17, z - pointer + 13)
                    txt ("~F@9                            ")
                    locate (18, z - pointer + 13)
                    txt (newlist[z][1]) 
                    if newlist[z][2] = 'd' and
                    compare (newlist[z][1], ".") != 0 and
                    compare (newlist[z][1], "..") != 0 then
                        txt ("/")
                    end if
                    txt ("@1")                   
                else
                    locate (18, z - pointer + 13)
                    txt ("~9                           ")                    
                    locate (18, z - pointer + 13)
                    txt (newlist[z][1])
                    if newlist[z][2] = 'd' and
                    compare (newlist[z][1], ".") != 0 and
                    compare (newlist[z][1], "..") != 0 then
                        txt ("/")
                    end if
                end if   
            end for    
            -- Show boards 'on top' if any
            if pointer != 1 then
                for m = pointer - 1 to pointer - 5 by -1 do
                    if m < 1 then
                        locate (17, m - pointer + 13)
                        txt ("                            ")                    
                        exit    
                    end if  
                    locate (18, m - pointer + 13)
                    txt ("~9                           ")                    
                    locate (18, m - pointer + 13)
                    txt (newlist[m][1])                                        
                    if newlist[m][2] = 'd' and
                    compare (newlist[m][1], ".") != 0 and
                    compare (newlist[m][1], "..") != 0 then
                        txt ("/")
                    end if
                end for
            end if
            -- Corrects for a bug ... who knows why I need to do this .....
            if pointer = 1 then
                locate (17, 12)
                txt ("                            ")                
            end if
            update = 0
        end if
        key = get_key ()
        if key = k_up and pointer > 1 then  -- Up
            pointer = pointer - 1    
            update = 1
        elsif key = k_down and pointer < dirlength then  -- Down
            pointer = pointer + 1    
            update = 1
        elsif key = 327 and pointer > 1 then  -- Home (top)
            pointer = 1
            display_text_image ({3, 10}, loadfile_screen)
            update = 1         
        elsif key = 335 and pointer < dirlength then  -- End (bott)
            pointer = dirlength
            display_text_image ({3, 10}, loadfile_screen)
            update = 1    
        elsif key = 329 then  -- PgUp
            if pointer - 6 < 1 and pointer != 1 then
                pointer = 1
                display_text_image ({3, 10}, loadfile_screen)
                update = 1            
            elsif pointer > 1 then
                pointer = pointer - 6    
                display_text_image ({3, 10}, loadfile_screen)
                update = 1            
            end if                   
        elsif key = 337 then  -- PgDown
            if pointer + 6 > dirlength and pointer != dirlength then
                pointer = dirlength
                display_text_image ({3, 10}, loadfile_screen)
                update = 1            
            elsif pointer < dirlength then               
                pointer = pointer + 6    
                display_text_image ({3, 10}, loadfile_screen)
                update = 1            
            end if
        end if
        if key = 13 or key = ' ' then
            if newlist[pointer][2] = 'f' then
                exit
            else
                bah = chdir (newlist[pointer][1])
                newlist = grabdir (wildcard)
                dirlength = length (newlist) 
                pointer = 1                   
                update = 1
                display_text_image ({3, 10}, loadfile_screen)
                locate (12, 4)
                txtf ("@8~FSelect %s to load", {title})
            end if
        end if   
        if key = 27 then
            exit
        end if
    end while                                 
    display_text_image ({3, 10}, back)
    if key = 13 or key = ' ' then
        return newlist[pointer][1]
    else
        return -1    
    end if
end function

